/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/fs/fs.hpp>
#include <ox/std/memory.hpp>
#include <ox/std/stringview.hpp>

#include "assetmanager.hpp"

namespace nostalgia::foundation {

class Context {
	public:
		ox::UPtr<ox::FileSystem> rom;
		ox::StringView appName = "Nostalgia Foundation App";
#ifndef OX_BARE_METAL
		AssetManager assetManager;
		ox::Vector<class BaseConverter*> converters;
#else
		std::size_t preloadSectionOffset = 0;
#endif

		constexpr Context() noexcept = default;
		Context(const Context&) noexcept = delete;
		Context(Context&&) noexcept = delete;
		Context &operator=(const Context&) noexcept = delete;
		Context &operator=(Context&&) noexcept = delete;
		constexpr virtual ~Context() noexcept = default;
};

}
