/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include "module.hpp"

namespace nostalgia::foundation {

[[nodiscard]]
static ox::Vector<const Module*> *moduleRegistry() noexcept {
#ifdef OX_BARE_METAL
	return nullptr;
#else
	static ox::Vector<const Module*> modules;
	return &modules;
#endif
}

void registerModule(const Module *mod) noexcept {
	auto mods = moduleRegistry();
	if (mods) {
		mods->emplace_back(mod);
	}
}

[[nodiscard]]
const ox::Vector<const Module*> *modules() noexcept {
	return moduleRegistry();
}


ox::Vector<foundation::BaseConverter*> Module::converters() const noexcept {
	return {};
}

}
